## Script (Python) "get_grufspaces_ftests"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
selenium = context.portal_selenium
suite = selenium.getSuite()
target_language='en'
suite.setTargetLanguage(target_language)
plone21 = selenium.getPloneVersion() > "2.0.5"

group_prefix = "group_"
if plone21:
    group_prefix=""

if context.portal_types.Folder.product == 'ATContentTypes':
    FOLDER_SAVE_BUTTON = "form_submit"
    FOLDER_SAVE_MSG = "Your changes have been saved."
else:
    FOLDER_SAVE_BUTTON = "form.button.Save"
    FOLDER_SAVE_MSG = "Folder changes saved."

if context.portal_types.Document.product == 'ATContentTypes':
    DOCUMENT_SAVE_BUTTON = "form_submit"
    DOCUMENT_SAVE_MSG = "Your changes have been saved."
else:
    DOCUMENT_SAVE_BUTTON = "form.button.Save"
    DOCUMENT_SAVE_MSG = "Document changes saved."
    
# Any GroupMember can delete the content of other GroupMembers
groupmembers_can_delete_other_groupmember_documents=1

# Any GroupMember can edit the content of other GroupMembers
groupmembers_can_edit_other_groupmember_documents=1

# Documents inside a closed GroupSpace are not visible to the outside
documents_not_visible_in_closed_groupspace=1

# Normal Members can not access a GroupSpace
groupspace_not_accessible_to_members=1

selenium.addUser(id = 'sampleadmin',fullname='Sample Admin',roles=['Member', 'Manager',])
selenium.addUser(id = 'samplemember',fullname='Sample Group Member',roles=['Member',])
selenium.addUser(id = 'samplegroupmember',fullname='Sample Group Member',roles=['Member',])
selenium.addUser(id = 'othergroupmember',fullname='Other Group Member',roles=['Member',])
selenium.addUser(id = 'samplegroupvisitor',fullname='Sample Group Visitor',roles=['Member',])
selenium.addUser(id = 'samplegroupadmin',fullname='Sample Group Admin',roles=['Member',])
selenium.addUser(id = 'samplegroupleader',fullname='Sample Group Leader',roles=['Member',])
selenium.addGroup(id = 'samplegroup',roles=[])
selenium.addGroup(id = 'samplegroup_1',roles=[])
selenium.addGroup(id = 'samplegroup_2',roles=[])

# 1
test_logout = suite.TestLogout()
test_admin_login  = suite.TestLoginPortlet('sampleadmin')
test_member_login  = suite.TestLoginPortlet('samplemember')
test_samplegroupmember_login  = suite.TestLoginPortlet('samplegroupmember')
test_othergroupmember_login  = suite.TestLoginPortlet('othergroupmember')
test_groupvisitor_login  = suite.TestLoginPortlet('samplegroupvisitor')
test_groupadmin_login  = suite.TestLoginPortlet('samplegroupadmin')
test_groupleader_login  = suite.TestLoginPortlet('samplegroupleader')
test_switch_language = suite.TestSwitchToLanguage()

group_folder = 'groups'
group_id = 'samplegroup'
groupspace_path = '/' + group_folder + '/' + group_id
document_id = 'testdocument'

test_add_group = t = suite.getTest()
# Add Group
if plone21:
    t.open("/folder_delete?paths:list=%s" % t.base + '/' + group_folder)
else:
    t.open("/folder_delete?ids:list=%s" % group_folder)
t.open("/")

# Let's add the GroupSpace
t.clickAndWait( "link=Folder")
# Fill in the form
t.type("id", group_folder)
t.type("title", "Groups")
t.type("description", "Groups")
# Save
t.clickAndWait(FOLDER_SAVE_BUTTON)
t.verifyTextPresent(FOLDER_SAVE_MSG)

test_add_groupspace = t = suite.getTest()
# Add GroupSpace
# Delete existing GroupSpace for a fresh start
if plone21:
    t.open("/%s/folder_delete?paths:list=%s" % (group_folder, t.base + groupspace_path))
else:
    t.open("/%s/folder_delete?ids:list=%s" % (group_folder, group_id))
t.open("/" + group_folder)

# Let's add the GroupSpace
t.clickAndWait( "//a[contains(text(),'GroupSpace')]")
# Fill in the form
t.type("id", group_id)
t.type("title", "Test GroupSpace")
t.type("description", "This is a Test Groupspace")
# Save
t.clickAndWait( "form.button.Save")
t.verifyTextPresent("GroupSpace changes saved.")

test_share_groupspace = t = suite.getTest()
# Share GroupSpace
t.open("%s/folder_localrole_form" % groupspace_path)
# samplegroupmember
t.open("%s/folder_localrole_edit?change_type=add&"\
       "member_ids:list=%s&member_role=%s" % (groupspace_path,
                                              'samplegroupmember',
                                              'GroupMember'))
t.verifyTextPresent("Local Roles changed."),
# othergroupmember
t.open("%s/folder_localrole_edit?change_type=add&"\
       "member_ids:list=%s&member_role=%s" % (groupspace_path,
                                             'othergroupmember',
                                             'GroupMember'))
t.verifyTextPresent("Local Roles changed."),
t.open("%s/folder_localrole_edit?change_type=add&"\
       "member_ids:list=%s&member_role=%s" % (groupspace_path,
                                              'samplegroupvisitor',
                                              'GroupVisitor'))
t.verifyTextPresent("Local Roles changed."),
t.open("%s/folder_localrole_edit?change_type=add&"\
       "member_ids:list=%s&member_role=%s" % (groupspace_path,
                                              'samplegroupadmin',
                                              'GroupAdmin'))
t.verifyTextPresent("Local Roles changed."),
t.open("%s/folder_localrole_edit?change_type=add&"\
       "member_ids:list=%s&member_role=%s" % (groupspace_path,
                                              'samplegroupadmin',
                                              'GroupMember'))
t.verifyTextPresent("Local Roles changed."),
t.open("%s/folder_localrole_edit?change_type=add&"\
       "member_ids:list=%s&member_role=%s" % (groupspace_path,
                                              'samplegroupleader',
                                              'GroupLeader'))
t.verifyTextPresent("Local Roles changed."),
t.open("%s/folder_localrole_edit?change_type=add&"\
       "member_ids:list=%s&member_role=%s" % (groupspace_path,
                                              'samplegroupleader',
                                              'GroupMember'))
t.verifyTextPresent("Local Roles changed."),

test_add_content = t = suite.getTest()
if plone21:
    t.open("%s/folder_delete?paths:list=%s" % (groupspace_path, groupspace_path + '/' + document_id) )
else:
    t.open("%s/folder_delete?ids:list=%s" % (groupspace_path, document_id) )
t.open(groupspace_path)

if plone21:
    t.clickAndWait( "//a[contains(text(),'Page')]")
else:
    t.clickAndWait( "//a[contains(text(),'Document')]")

t.type("id", document_id)
t.type("title", "Test Document")
t.type("description","This is a test document")
t.type("text","QWERTY")
t.clickAndWait(DOCUMENT_SAVE_BUTTON)
t.verifyTextPresent(DOCUMENT_SAVE_MSG)

other_document_id = 'othertestdocument'

test_add_other_content = t = suite.getTest()
if plone21:
    t.open("%s/folder_delete?paths:list=%s" % (groupspace_path, groupspace_path + '/' + other_document_id) )
else:
    t.open("%s/folder_delete?ids:list=%s" % (groupspace_path, other_document_id) )
t.open(groupspace_path)

if plone21:
    t.clickAndWait( "//a[contains(text(),'Page')]")
else:
    t.clickAndWait( "//a[contains(text(),'Document')]")
t.type("id", other_document_id)
t.type("title", "Other Test Document")
t.type("description","This is another test document")
t.type("text","This is the body text of another test document")
t.clickAndWait(DOCUMENT_SAVE_BUTTON)
t.verifyTextPresent(DOCUMENT_SAVE_MSG)

test_delete_document = t = suite.getTest()
if plone21:
    t.open("%s/folder_delete?paths:list=%s" % (groupspace_path, t.base + groupspace_path + '/' + document_id))
else:
    t.open("%s/folder_delete?ids:list=%s" % (groupspace_path, document_id))

test_delete_other_document = t = suite.getTest()
if plone21:
    t.open("%s/folder_delete?paths:list=%s" % (groupspace_path, t.base + groupspace_path + '/' + other_document_id))
else:
    t.open("%s/folder_delete?ids:list=%s" % (groupspace_path, other_document_id))

if groupmembers_can_delete_other_groupmember_documents:
    document_deleted_or_not = t = suite.getTest()
    t.verifyTextPresent("Test Document has been deleted.")
else:
    document_deleted_or_not  = t = suite.getTest()
    t.verifyTextPresent("Please select one or more items to delete.")

test_delete_groupvisitor = t = suite.getTest()
t.open("%s/GroupSpace_rolesForm" % groupspace_path)
t.click("samplegroupvisitor/GroupVisitor")
t.clickAndWait("form.button.Delete")
t.verifyTextPresent("Role assignment changed.")
          
test_add_groupvisitor = t = suite.getTest()
t.open("%s/GroupSpace_rolesForm" % groupspace_path)
t.type('user_search_term','samplegroupvisitor')
t.clickAndWait("perform_user_search")
t.select("user_collab_role", "GroupVisitor")
t.clickAndWait("form.button.Save")
t.verifyTextPresent("Role assignment changed.")

suite.addTests("GrufSpaces",
          'Login as Sample Admin',
          test_admin_login,
          test_switch_language,
          'Add Group',
          test_add_group,
          'Add GroupSpace',
          test_add_groupspace,
          'Share GroupSpace',
          test_share_groupspace,
          'Login as Sample Group Member',
          test_samplegroupmember_login,
          test_switch_language,
          'Add content',
          test_add_content,
          'Login as Other Group Member',
          test_othergroupmember_login,
          test_switch_language,
          'Add content',
          test_add_other_content,
          'Delete content',
          test_delete_document,
          document_deleted_or_not,
          test_delete_other_document,
          suite.verifyTextPresent("Other Test Document has been deleted."),
         )

suite.addTests("GroupAdmin",
          'Login as Sample Admin',
          test_admin_login,
          test_switch_language,
          'Configure user search',
          suite.open('/prefs_grufspaces_form'),
          suite.click('user_search_in_grufspaces_on'),
          suite.clickAndWait('form.button.Save'),   
          suite.verifyTextPresent('GrufSpaces configuration updated.'),
          suite.verifyValue('user_search_in_grufspaces:int','on'),
          'Add Group',
          test_add_group,
          'Add GroupSpace',
          test_add_groupspace,
          'Share GroupSpace',
          test_share_groupspace,
          'Login as Group Admin',
          test_groupadmin_login,
          test_switch_language,
          'Delete GroupVisitor role of samplegroupvisitor',
          test_delete_groupvisitor,
          'Add GroupVisitor role to samplegroupvisitor',
          test_add_groupvisitor,
          )

suite.addTests("GroupLeader",
          'Login as Sample Admin',
          test_admin_login,
          test_switch_language,
          'Configure user search',
          suite.open('/prefs_grufspaces_form'),
          suite.click('user_search_in_grufspaces_on'),
          suite.clickAndWait('form.button.Save'),   
          'Add Group',
          test_add_group,
          'Add GroupSpace',
          test_add_groupspace,
          'Share GroupSpace',
          test_share_groupspace,
          'Login as Group Leader',
          test_groupleader_login,
          test_switch_language,
          'Delete GroupVisitor role of samplegroupvisitor',
          test_delete_groupvisitor,
          'Add GroupVisitor role to samplegroupvisitor',
          test_add_groupvisitor,      
          'Open GroupSpace',
          suite.open("%s/content_status_modify?workflow_action=open" % groupspace_path),
         )


# The content of closed GroupSpaces should not be visible to the outside
# When switching between open and closed GroupSpaces, the documents inside
# should automatically become visible and invisible to the outside.

suite.addTests("Visibility to the outside",
          'Login as Sample Admin',
          test_admin_login,
          test_switch_language,
          'Add Group',
          test_add_group,
          'Add GroupSpace',
          test_add_groupspace,
          'Share GroupSpace',
          test_share_groupspace,
          'Login as Sample Group Member',
          test_samplegroupmember_login,
          test_switch_language,
          'Add content',
          test_add_content,
          'Search content inside GroupSpace',
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("1 items matching your criteria"),
          'Login as Sample Member',
          test_member_login,
          'Try accessing the GroupSpace',
          suite.open("%s/" % groupspace_path),
          suite.verifyTextPresent("Insufficient Privileges"),
          'Search content inside GroupSpace',
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("1 items matching your criteria"),
          'Login as Sample Admin',
          test_admin_login,
          'Close GroupSpace',
          suite.open("%s/content_status_modify?workflow_action=close" % groupspace_path),
         )

suite.addTests("User Search in Roles Form",
          'Login as Sample Admin',
          test_admin_login,
          test_switch_language,
          'Configure user search',
          suite.open('/prefs_grufspaces_form'),
          suite.click('user_search_in_grufspaces_on'),
          suite.clickAndWait('form.button.Save'),   
          suite.verifyTextPresent('GrufSpaces configuration updated.'),
          suite.verifyValue('user_search_in_grufspaces:int','on'),
          'Search without search term',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementNotPresent('assign_users_to_role'),          
          suite.verifyElementPresent('perform_user_search'),
          suite.clickAndWait('perform_user_search'),
          suite.verifyElementPresent('assign_users_to_role'),          
          suite.verifyElementNotPresent('perform_user_search'),
          'Search without search term and assign without selecting',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.clickAndWait('perform_user_search'),
          suite.clickAndWait('assign_users_to_role'),
          suite.verifyTextPresent('Please make a selection.'),
          'Search for existing',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementNotPresent('assign_users_to_role'),          
          suite.verifyElementPresent('perform_user_search'),
          suite.type('user_search_term', 'samplemember'),
          suite.clickAndWait('perform_user_search'),
          suite.verifyElementPresent('assign_users_to_role'),          
          suite.verifyElementNotPresent('perform_user_search'),          
          suite.verifyElementPresent("//input[@value='samplemember']"),
          'Search for non-existing',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementNotPresent('assign_users_to_role'),          
          suite.verifyElementPresent('perform_user_search'),
          suite.type('user_search_term', 'nonexistinguser'),
          suite.clickAndWait('perform_user_search'),
          suite.verifyElementNotPresent('assign_users_to_role'),          
          suite.verifyElementPresent('perform_user_search'),          
          suite.verifyTextPresent("No members were found"),

         )

suite.addTests("User Selection in Roles Form",
          'Login as Sample Admin',
          test_admin_login,
          test_switch_language,          
          'Configure User Selection',
          suite.open('/prefs_grufspaces_form'),
          suite.click('user_search_in_grufspaces_off'),
          suite.clickAndWait('form.button.Save'),
          suite.verifyTextPresent('GrufSpaces configuration updated.'),
          suite.verifyValue('user_search_in_grufspaces:int','off'),
          'Assign role to no user should fail',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementPresent('assign_users_to_role'),          
          suite.verifyElementNotPresent('perform_user_search'),
          suite.clickAndWait('assign_users_to_role'),
          suite.verifyTextPresent('Please make a selection.'),
          suite.verifyElementNotPresent('perform_user_search'),
          'Assign role to user should work',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementPresent('assign_users_to_role'),          
          suite.verifyElementNotPresent('perform_user_search'),
          suite.click("//input[@value='samplemember']"),         
          suite.clickAndWait('assign_users_to_role'),
          suite.verifyTextPresent('Role assignment changed.'),
          suite.verifyElementNotPresent('perform_user_search'),
          )

suite.addTests("Group Search in Roles Form",
          'Login as Sample Admin',
          test_admin_login,
          test_switch_language,          
          'Configure Group Search',
          suite.open('/prefs_grufspaces_form'),
          suite.click('group_search_in_grufspaces_on'),
          suite.clickAndWait('form.button.Save'),
          suite.verifyTextPresent('GrufSpaces configuration updated.'),
          suite.verifyValue('group_search_in_grufspaces:int','on'),
          'Search without search term',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementNotPresent('assign_groups_to_role'),          
          suite.verifyElementPresent('perform_group_search'),
          suite.clickAndWait('perform_group_search'),
          suite.verifyElementPresent('assign_groups_to_role'),          
          suite.verifyElementNotPresent('perform_group_search'),          
          'Search without search term and assign without selecting',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.clickAndWait('perform_group_search'),
          suite.clickAndWait('assign_groups_to_role'),
          suite.verifyTextPresent('Please make a selection.'),
          'Search for existing group',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementNotPresent('assign_groups_to_role'),          
          suite.verifyElementPresent('perform_group_search'),
          suite.type('group_search_term', 'samplegroup_1'),
          suite.clickAndWait('perform_group_search'),
          suite.verifyElementPresent('assign_groups_to_role'),          
          suite.verifyElementNotPresent('perform_group_search'),          
          suite.verifyElementPresent("//input[@value='"+ group_prefix + "samplegroup_1']"),
          'Search for non-existing group',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementNotPresent('assign_groups_to_role'),          
          suite.verifyElementPresent('perform_group_search'),
          suite.type('group_search_term', 'nonexistinggroup'),
          suite.clickAndWait('perform_group_search'),
          suite.verifyElementNotPresent('assign_groups_to_role'),          
          suite.verifyElementPresent('perform_group_search'),          
          suite.verifyTextPresent("No groups were found"),
          )

          
suite.addTests("Group Selection in Roles Form",
          'Login as Sample Admin',
          test_admin_login,
          test_switch_language,          
          'Configure Group Selection',
          suite.open('/prefs_grufspaces_form'),
          suite.click('group_search_in_grufspaces_off'),
          suite.clickAndWait('form.button.Save'),          
          suite.verifyTextPresent('GrufSpaces configuration updated.'),
          suite.verifyValue('group_search_in_grufspaces:int','off'),
          'Assign role no group should fail',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementPresent('assign_groups_to_role'),          
          suite.verifyElementNotPresent('perform_group_search'),
          suite.clickAndWait('assign_groups_to_role'),
          suite.verifyTextPresent('Please make a selection.'),
          suite.verifyElementNotPresent('perform_group_search'),
          'Assign role to group should work',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementPresent('assign_groups_to_role'),          
          suite.verifyElementNotPresent('perform_group_search'),
          suite.click("//input[@value='"+ group_prefix + "samplegroup']"),
          suite.clickAndWait('assign_groups_to_role'),
          suite.verifyTextPresent('Role assignment changed.'),
          suite.verifyElementNotPresent('perform_group_search'),
         )

suite.addTests("Remove all roles in Roles Form",
          'Login as Sample Admin',
          test_admin_login,
          test_switch_language,          
          'Configure user selection',
          suite.open('/prefs_grufspaces_form'),
          suite.click('user_search_in_grufspaces_off'),
          suite.clickAndWait('form.button.Save'),
          'Make sure there is at least one user with a role',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.click("//input[@value='samplemember']"),         
          suite.clickAndWait('assign_users_to_role'),
          'Configure group selection',
          suite.open('/prefs_grufspaces_form'),
          suite.click('group_search_in_grufspaces_off'),
          suite.clickAndWait('form.button.Save'),
          'Make sure there is at least one group with a role',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.click("//input[@value='" + group_prefix + "samplegroup']"),         
          suite.clickAndWait('assign_groups_to_role'),          
          'Remove roles',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.click('alr_toggle'),
          suite.clickAndWait('form.button.Delete'),
          suite.verifyTextPresent('Role assignment changed.'),
          )


return suite
