#                                                       #
#                 Test GroupUserFolder                  #
#                                                       #
#                                                       #
# (c)2002 Ingeniweb                                     #

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

# Load fixture
from Testing import ZopeTestCase
from Products.CMFPlone.tests import PloneTestCase

from Products.GrufSpaces.GroupSpace import GroupSpace

# Install our product
ZopeTestCase.installProduct('GroupUserFolder')
ZopeTestCase.installProduct('GrufSpaces')

class TestGrufSpaces(PloneTestCase.PloneTestCase):

    def afterSetUp(self):
        self.loginPortalOwner()
        self.qi = self.portal.portal_quickinstaller
        self.qi.installProduct('GrufSpaces')
        self.portal._addRole('GroupMember')
        self.portal.invokeFactory('GroupSpace', 'gs')
        self.gs = self.portal.gs

    #                                                   #
    #           Basic GRUF behaviour testing            #
    #                                                   #

    def testBasicInfo(self):
        self.assertEquals('gs', self.gs.getId())
        self.assertEquals('GroupSpace', self.gs.Type())
        self.assertEquals('GroupSpace', self.gs.meta_type)
        self.gs.edit(title='GS', description='My Plone Group Space')
        self.assertEquals('GS', self.gs.Title())
        self.assertEquals('My Plone Group Space', self.gs.Description())
        pt = self.portal.portal_types
        fti = pt.getTypeInfo('GroupSpace')
        self.assertEquals('GroupSpace_listing', fti.getActionById('view'))
        # DEPRECATED : Now use use_folder_tabs properties (See install.py)
        #self.assertEquals('GroupSpace_contents', fti.getActionById('folderlisting'))
        self.assertEquals('GroupSpace_editForm', fti.getActionById('edit'))


if __name__ == '__main__':
    framework(descriptions=1, verbosity=1)
else:
    from unittest import TestSuite, makeSuite
    def test_suite():
        suite = TestSuite()
        suite.addTest(makeSuite(TestGrufSpaces))
        return suite

